#include <tty/sss_zero.hpp>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <boost/cstdint.hpp>
#include <tty/scc.hpp>
#include <tty/bass.hpp>
#include <tty/alib.hpp>

#define OMEGABOOST

typedef tty::alib<float> alib;

struct bullet_type{
	int frame;
	float omega;
	float speed;
};

struct cmp{
    bool operator()(const bullet_type &a, const bullet_type &b) const{
		return a.frame < b.frame;
	}
};

bool tfm(const tty::bass::sample &isample, const char *opath){
	//f[^tH[}bg
	//-------- wb_
	//[1byte	char]	`l
	//-------- e
	//[4byte	int]	ot[
	//[4byte	float]	ˏopx
	//[4byte	float]	x
	//-------- eۏI[
	//[4byte	int]	-1
	//-------- `ln̏ꍇ[e][eۏI[]nZbg
	std::fstream ofile(opath, std::ios::binary | std::ios::out);
	if(ofile.fail()){
		std::cout << "o̓t@C̐Ɏs܂." << std::endl;
		return false;
	}
	typedef tty::scc::deque<bullet_type> deque_t;
	bullet_type bullet;
	deque_t deque;
	boost::int32_t bit32;
	boost::int8_t bit8;
	const int
		framerate = 60,
		d1fftboxnum = 64,
		d2fftbuffer = 32,
		pf = isample.freq() / framerate;
	alib::fftbox *d1fftbox[d1fftboxnum], d2fftbox(d1fftboxnum);
	alib::arithmetic_type d1buffer[d1fftboxnum], d1buffer_ntv[d1fftboxnum], d2buffer[d2fftbuffer];
	for(int i = 0; i < d1fftboxnum; ++i){
		d1fftbox[i] = new alib::fftbox(1024);
	}
	//`l
	bit8 = static_cast<boost::int8_t>(isample.chans());
	ofile.write(reinterpret_cast<const char*>(&bit8), sizeof(bit8));
	//ϊ
	for(int cc = 0, ccend = static_cast<int>(isample.chans()); cc < ccend; ++cc){
		//LbJԂ
		for(int i = 0, ie = isample.length() / isample.freq(); i < ie; ++i){
			std::cout << (i + 1) << " / " << ie << " : " << (cc + 1) << " / " << 2 << std::endl;
			//i[
			for(int j = 0; j < framerate; ++j){
				for(int k = 0; k < pf; ++k){
					d1fftbox[j]->set(k, alib::num(isample.data_hs(cc, i * isample.freq() + j * pf + k)) / alib::num(1 << (16 - 1)));
				}
				for(int k = 0, ke = 1024 - pf; k < ke; ++k){
					d1fftbox[j]->set(pf + k, alib::num(isample.data_hs(cc, i * isample.freq() + j * pf + k)) / alib::num(1 << (16 - 1)));
				}
			}
			for(int j = 0, je = d1fftboxnum - framerate; j < je; ++j){
				for(int k = 0, ke = pf; k < ke; ++k){
					d1fftbox[framerate + j]->set(k, alib::num(isample.data_hs(cc, i * isample.freq() + j * pf + k)) / alib::num(1 << (16 - 1)));
				}
				for(int k = 0, ke = 1024 - pf; k < ke; ++k){
					d1fftbox[framerate + j]->set(pf + k, alib::num(isample.data_hs(cc, i * isample.freq() + j * pf + k)) / alib::num(1 << (16 - 1)));
				}
			}
			//ϊ 1
			for(int j = 0; j < d1fftboxnum; ++j){
				d1fftbox[j]->transform();
			}
			//gƂɏ
			for(int j = 0, je = d1fftbox[0]->rms(); j < je; ++j){
				//Ԏɕϊăobt@ɃZbg ς߂
				alib::arithmetic_type avg = alib::num(0);
				for(int k = 0; k < d1fftboxnum; ++k){
					d1buffer_ntv[k] = d1fftbox[k]->power(j);
					d1buffer[k] = d1buffer_ntv[k];
					avg += d1buffer[k];
				}
				avg /= alib::num(d1fftboxnum);
				//ϒl0ɂȂlɐK Βl̍ől߂
				alib::arithmetic_type maxp = alib::num(0), tmp;
				for(int k = 0; k < d1fftboxnum; ++k){
					d1buffer[k] -= avg;
					tmp = std::abs(d1buffer[k]);
					if(tmp > maxp){
						maxp = tmp;
					}
				}
				//ől1ɂȂlɐK d2fftboxɃZbg
				if(maxp == alib::num(0)){
					for(int k = 0; k < d1fftboxnum; ++k){
						d2fftbox.set(k, 0);
					}
				}else{
					for(int k = 0; k < d1fftboxnum; ++k){
						d1buffer[k] /= maxp;
						d2fftbox.set(k, d1buffer[k]);
					}
				}
				//ϊ 2
				d2fftbox.transform();
				//obt@Ɋi[
				for(int k = 0, ke = d2fftbox.rms(); k < ke; ++k){
					d2buffer[k] = d2fftbox.power(k);
				}
				//őlƍŏl𓾂
				alib::arithmetic_type d2max = alib::num(0), d2min = alib::num(0);
				for(int k = 0, ke = d2fftbox.rms(); k < ke; ++k){
					if(d2buffer[k] < d2min){
						d2min = d2buffer[k];
					}else if(d2buffer[k] > d2max){
						d2max = d2buffer[k];
					}
				}
				//K
				alib::arithmetic_type threshold = alib::num(3.5);
				bool createflag = false;
				//Y琶
				for(int k = 0, ke = d2fftbox.rms(); k < ke; ++k){
					alib::arithmetic_type x = d2buffer[k] * threshold;
					int power = static_cast<int>(x);
					if(power){
						createflag = true;
#ifndef OMEGABOOST
						bullet.omega = alib::num(cc) * alib::pi() + alib::pi() * alib::num(j) / alib::num(je) - (alib::pi() / 2);
						bullet.speed = alib::num(2.5) * d2buffer[k];
#endif
						for(int l = 0, le = k + 1; l < le; ++l){
#ifdef OMEGABOOST
							bullet.omega =
								alib::num(cc) * alib::pi() +
								alib::pi() * alib::num(j) / alib::num(je) +
								alib::pi() * alib::num(l) / alib::num(le) -
								(alib::pi() / 2);
							bullet.speed = alib::num(1.0) * d2buffer[k] + alib::num(1.5) * (d2buffer[k] - d2min);
#endif
							bullet.frame = i * framerate + static_cast<int>(alib::num(framerate) * alib::num(l) / alib::num(le));
							deque.push_back(bullet);
						}
					}
				}
				//ʂ琶
				//if(!createflag){
				//	const int tx = 1 << 14;
				//	for(int k = 0; k < framerate; ++k){
				//		if(d1buffer_ntv[k] > alib::num(tx)){
				//			bullet.omega = alib::num(cc) * alib::pi() + alib::pi() * alib::num(j) / alib::num(je) - (alib::pi() / 2);
				//			bullet.speed = alib::num(1.5) + alib::num(1.5) * (d1buffer_ntv[k] - alib::num(tx)) / alib::num(tx);
				//			bullet.frame = i * framerate + k;
				//			deque.push_back(bullet);
				//		}
				//	}
				//}
			}
		}
		//\[g
		std::sort(deque.begin(), deque.end(), cmp());
		//
		for(
			deque_t::const_iterator it = deque.begin(), end = deque.end();
			it != end;
			++it
		){
			bullet.frame = it->frame;
			bullet.omega = it->omega;
			bullet.speed = it->speed;
			ofile.write(reinterpret_cast<const char*>(&bullet.frame), sizeof(bullet.frame));
			ofile.write(reinterpret_cast<const char*>(&bullet.omega), sizeof(bullet.omega));
			ofile.write(reinterpret_cast<const char*>(&bullet.speed), sizeof(bullet.speed));
		}
		//I[
		bit32 = -1;
		ofile.write(reinterpret_cast<const char*>(&bit32), sizeof(bit32));
	}
	for(int i = 0; i < d1fftboxnum; ++i){
		delete d1fftbox[i];
	}
	return true;
}

int main(int argc, char *argv[]){
	tty::bass bass;
	//g\
	if(argc != 3){
#ifdef OMEGABOOST
#define ISBOOST " omegaboost "
#else
#define ISBOOST ""
#endif
		std::cout
			<< "* e eϊ" ISBOOST "*" << std::endl
			<< "1ɕϊ̃t@Cw肵Ă." << std::endl
			<< "2ɐt@Cw肵Ă." << std::endl;
		return 0;
	}
	//ǂݍ
	tty::bass::sample sample(bass.fsampleload(argv[1]));
	if(sample.fail()){
		std::cout << "wavt@C̓ǂݍ݂Ɏs܂." << std::endl;
		return 0;
	}
	//TvO[g`FbN
	if(sample.freq() != 44100){
		std::cout << "44100ȊÕTvO[gɂ͑ΉĂ܂." << std::endl;
		return 0;
	}
	//ϊ
	if(tfm(sample, argv[2])){
		std::cout << "ɏI܂." << std::endl;
	}else{
		std::cout << "ϊɎs܂." << std::endl;
	}

	return 0;
}

